jv.viewer

## Class PvScenegraph

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Panel
      - - jv.viewer.PvScenegraph

- All Implemented Interfaces:
    java.awt.event.AdjustmentListener, java.awt.event.MouseListener, java.awt.event.MouseMotionListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, PvDisplayOverlayIf

      public class PvScenegraph
      extends java.awt.Panel
      implements PvDisplayOverlayIf, java.awt.event.AdjustmentListener

  Gui canvas showing a tree-based explorer view. Used in PvDisplay as scene graph and in tree view.

  This class is in beta.

  Since:
    JavaView v4.81.003, formerly in alpha mode.
  See Also:
    Serialized Form
  Author:
    Konrad Polthier
  Version:
    09.02.14, 2.00 revised (kp) First running beta within JavaView display.
    14.12.13, 1.00 created (kp) Extending earlier work on jvTree.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `BGCOLOR` Indices of specific colors in color array m_color.
    `static int` | `HBGCOLOR`
    `static int` | `HTXTBGCOLOR`
    `static int` | `HTXTCOLOR`
    `static int` | `MODE_OVERLAY`
    `static int` | `MODE_PANEL`
    `static int` | `OUTLINE`
    `static int` | `TXTCOLOR`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PvScenegraph()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `adjustmentValueChanged(java.awt.event.AdjustmentEvent event)`
    `int` | `getIconInd()` Get index of icon resp. field with currently picked node.
    `java.lang.String` | `getNodeID()` Get ID of current picked node.
    `int` | `getNodeInd()` Get index of current picked node.
    `java.lang.String` | `getNodeStatus()` Get status of directory nodes (open/close).
    `int` | `getPanelMode()` Get flag if running as self-contained panel or as overlay of another container panel.
    `java.awt.Dimension` | `getPreferredSize()` Gets the preferred size of this component.
    `void` | `init()`
    `void` | `mouseClicked(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mouseDragged(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mouseEntered(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mouseExited(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mouseMoved(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mousePressed(java.awt.event.MouseEvent mouseEvent)`
    `void` | `mouseReleased(java.awt.event.MouseEvent mouseEvent)`
    `void` | `paint(java.awt.Graphics g)`
    `void` | `paintOverlay(java.awt.Graphics g, int xInset, int yInset, int width, int height)` Draw scenegraph as overlay in JavaView display.
    `void` | `selectColors(int bgColor, int txtColor, int hbgColor, int htxtColor)` Select color of special items using index in color array.
    `void` | `selectFonts(int titleFont, int nodeFont)` Select color of special items using index in color array.
    `void` | `setColors(java.awt.Color[] color)` Set colors, index identified using COLOR_xyz .
    `void` | `setDisplayComponent(java.awt.Component panel)` Set panel of of this container which provides graphics context.
    `void` | `setFonts(java.awt.Font[] font)` Set fonts, index identified using FONT_xyz .
    `void` | `setNodeIcons(java.awt.Image[] nodeImg, int numIcons)` Set icons of tree nodes and other gui elements.
    `void` | `setNodeParms(int iVersion, java.lang.String[] parmArray, int numParms)` Set list of tree nodes and node parameters, each node is given as string.
    `void` | `setPanelMode(int panelMode)` Set flag if running as self-contained panel or as overlay of another container panel.
    `void` | `setParent()`
    `void` | `setTitle(java.lang.String title)` Set title string.
    `void` | `update(java.awt.Graphics g)`

    - ### Methods inherited from class java.awt.Panel

      `addNotify, getAccessibleContext`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getInsets, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, isValidateRoot, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, dispatchEvent, enable, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### BGCOLOR

          public static int BGCOLOR

      Indices of specific colors in color array m_color.

    - #### TXTCOLOR

          public static int TXTCOLOR

    - #### HBGCOLOR

          public static int HBGCOLOR

    - #### HTXTCOLOR

          public static int HTXTCOLOR

    - #### HTXTBGCOLOR

          public static int HTXTBGCOLOR

    - #### OUTLINE

          public static int OUTLINE

    - #### MODE_PANEL

          public static final int MODE_PANEL

      See Also:
        Constant Field Values

    - #### MODE_OVERLAY

          public static final int MODE_OVERLAY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PvScenegraph

          public PvScenegraph()

  - ### Method Detail

    - #### init

          public void init()

    - #### getPanelMode

          public int getPanelMode()

      Get flag if running as self-contained panel or as overlay of another container panel.

    - #### setPanelMode

          public void setPanelMode(int panelMode)

      Set flag if running as self-contained panel or as overlay of another container panel. Default is panel mode like, for example, in tree_view.
      Specified by:
        `setPanelMode` in interface `PvDisplayOverlayIf`

    - #### getPreferredSize

          public java.awt.Dimension getPreferredSize()

      Gets the preferred size of this component.
      Specified by:
        `getPreferredSize` in interface `PvDisplayOverlayIf`
      Overrides:
        `getPreferredSize` in class `java.awt.Container`
      Returns:
        a dimension object indicating this component's preferred size

    - #### setParent

          public void setParent()

    - #### getNodeInd

          public int getNodeInd()

      Get index of current picked node.

    - #### getIconInd

          public int getIconInd()

      Get index of icon resp. field with currently picked node.

    - #### getNodeID

          public java.lang.String getNodeID()

      Get ID of current picked node.

    - #### getNodeStatus

          public java.lang.String getNodeStatus()

      Get status of directory nodes (open/close).

    - #### setTitle

          public void setTitle(java.lang.String title)

      Set title string.

    - #### setColors

          public void setColors(java.awt.Color[] color)

      Set colors, index identified using COLOR_xyz .
      Parameters:
        `color` - array of colors for gui elements

    - #### selectColors

          public void selectColors(int bgColor,
                                   int txtColor,
                                   int hbgColor,
                                   int htxtColor)

      Select color of special items using index in color array.
      Parameters:
        `bgColor` - index of background color of canvas
        `hbgColor` - index of highlighted background color of canvas
        `txtColor` - index of text color of canvas
        `htxtColor` - index of highlighted text color of canvas

    - #### setFonts

          public void setFonts(java.awt.Font[] font)

      Set fonts, index identified using FONT_xyz .
      Parameters:
        `font` - array of fonts for gui text

    - #### selectFonts

          public void selectFonts(int titleFont,
                                  int nodeFont)

      Select color of special items using index in color array.
      Parameters:
        `titleFont` - font for title
        `nodeFont` - font for node labels

    - #### setNodeIcons

          public void setNodeIcons(java.awt.Image[] nodeImg,
                                   int numIcons)

      Set icons of tree nodes and other gui elements.
      Parameters:
        `nodeImg` - icons of nodes and gui elements

    - #### setNodeParms

          public void setNodeParms(int iVersion,
                                   java.lang.String[] parmArray,
                                   int numParms)

      Set list of tree nodes and node parameters, each node is given as string.
      Parameters:
        `iVersion` - version number of formatting of node strings
        `parmArray` - array of nodes, each node given as formatted string
        `numParms` - number of nodes in array

    - #### mouseClicked

          public void mouseClicked(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseClicked` in interface `java.awt.event.MouseListener`

    - #### mouseEntered

          public void mouseEntered(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseEntered` in interface `java.awt.event.MouseListener`

    - #### mouseExited

          public void mouseExited(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseExited` in interface `java.awt.event.MouseListener`

    - #### mouseReleased

          public void mouseReleased(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseReleased` in interface `java.awt.event.MouseListener`

    - #### mousePressed

          public void mousePressed(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mousePressed` in interface `java.awt.event.MouseListener`

    - #### mouseDragged

          public void mouseDragged(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseDragged` in interface `java.awt.event.MouseMotionListener`

    - #### mouseMoved

          public void mouseMoved(java.awt.event.MouseEvent mouseEvent)

      Specified by:
        `mouseMoved` in interface `java.awt.event.MouseMotionListener`

    - #### update

          public void update(java.awt.Graphics g)

      Overrides:
        `update` in class `java.awt.Container`

    - #### paint

          public void paint(java.awt.Graphics g)

      Overrides:
        `paint` in class `java.awt.Container`

    - #### paintOverlay

          public void paintOverlay(java.awt.Graphics g,
                                   int xInset,
                                   int yInset,
                                   int width,
                                   int height)

      Draw scenegraph as overlay in JavaView display.
      Specified by:
        `paintOverlay` in interface `PvDisplayOverlayIf`

    - #### adjustmentValueChanged

          public void adjustmentValueChanged(java.awt.event.AdjustmentEvent event)

      Specified by:
        `adjustmentValueChanged` in interface `java.awt.event.AdjustmentListener`

    - #### setDisplayComponent

          public void setDisplayComponent(java.awt.Component panel)

      Set panel of of this container which provides graphics context.
      Specified by:
        `setDisplayComponent` in interface `PvDisplayOverlayIf`

"

The software JavaView? is copyright protected. All Rights Reserved.
"